<template>
  <v-container class="homePage">
    <v-row>
      <v-col cols="12">
        <CategoriesBar
          :productsprincipalCategories="productsprincipalCategories"
          @show-sub-categories="showSubCategories"
        />

        <SubCategoriesBar
          :productsSubCategories="productsSubCategories"
          @show-this-sub-category-products-list="goToThisCategoryProductList"
        />
      </v-col>
      <v-col cols="12">
        <RandomProductCaroussel
          :randomProductList="randomProductList"
          @go-to-this-article-details="goToProductDetails"
        />
      </v-col>
      <v-row cols="12">
        <v-col
          cols="12"
          lg="4"
          sm="6"
          md="3"
          class="product-boxes"
          v-for="(productItem, index) in productListByCategories"
          :key="index"
        >
          <CategoriesCatalogue
            class="product-box"
            @go-to-product-list-filtred-by-this-category="goToProductListFiltredByprincipalCategories"
            :productItem="productItem"
          />
        </v-col>
      </v-row>

      <v-col cols="12">
        <RandomShopCaroussel
          :randomShopList="randomShopList"
          @go-to-this-shop-details="goToShopDetails"
        />
      </v-col>
    </v-row>
  </v-container>
</template>

<script>
import CategoriesBar from "./CategoriesBar.vue";
import SubCategoriesBar from "./SubCategoriesBar.vue";
import RandomProductCaroussel from "./RandomProductCaroussel.vue";
import CategoriesCatalogue from "./CategoriesCatalogue.vue";
import RandomShopCaroussel from "./RandomShopCaroussel.vue";

import API from "@/API.js";
export default {
  name: "HomePage",
  components: {
    CategoriesBar,
    SubCategoriesBar,
    RandomProductCaroussel,
    CategoriesCatalogue,
    RandomShopCaroussel
  },
  props: {},
  data() {
    return {
      productsprincipalCategories: [],
      productsSubCategories: [],
      defaultSubCategory: "ropa",
      randomProductList: [],
      principalCategories: [],
      productListByCategories: [],
      randomShopList: []
    };
  },
  async mounted() {
    this.productsprincipalCategories = await API.downloadListOfprincipalCategories();
    this.productsSubCategories = await API.downloadListOfSubCategories(
      this.defaultSubCategory
    );
    this.randomProductList = await API.downloadrandomProductList();
    this.randomShopList = await API.downloadrandomShopList();
    this.principalCategories = await API.loadProductprincipalCategories();
    this.productListByCategories = await API.getProductByCategories();
  },
  methods: {
    async showSubCategories(searchedCategory) {
      this.productsSubCategories = await API.downloadListOfSubCategories(
        searchedCategory
      );
    },

    goToProductDetails(searchedProduct) {
      console.log(searchedProduct);
      this.$router.push("/Product-Details/" + searchedProduct);
    },

    goToShopDetails(searchedShop) {
      this.$router.push("/Shop-Details/" + searchedShop);
    },

    goToProductListFiltredByprincipalCategories(filtredPrincipalCategory) {
      this.$router.push(
        "/Product-List/filtred-by-Principal-Categories/" +
          filtredPrincipalCategory
      );
    },

    goToThisCategoryProductList(searchedSubCategory) {
      this.$router.push(
        "/Product-List/Principal-Categories/" + searchedSubCategory
      );
    }
  }
};
</script>


<style>
.class1 {
  width: 100%;
  display: flex;
  align-items: center;
  margin-top: 32px;
  position: relative;
  overflow: hidden;
}
</style>
